darcs-2.12.5: a distributed, interactive, smart revision control system

Safe Haskell | None
Language | Haskell2010

Darcs.Patch.Witnesses.WZipper

Synopsis

- data FZipper a wX wZ where
  - FZipper :: RL a wX wY -> FL a wY wZ -> FZipper a wX wZ
- focus :: FZipper a wX wY -> Maybe (Sealed2 a)
- leftmost :: FZipper p wX wY -> Bool
- left :: FZipper p wX wY -> FZipper p wX wY
- rightmost :: FZipper p wX wY -> Bool
- right :: FZipper p wX wY -> FZipper p wX wY
- jokers :: FZipper a wX wY -> FlippedSeal (FL a) wY
- clowns :: FZipper a wX wY -> Sealed (RL a wX)
- flToZipper :: FL a wX wY -> FZipper a wX wY
- lengthFZ :: FZipper a wX wY -> Int
- nullFZ :: FZipper a wX wY -> Bool
- toEnd :: FZipper p wX wY -> FZipper p wX wY
- toStart :: FZipper p wX wY -> FZipper p wX wY

# Documentation

data FZipper a wX wZ where #

Constructors

FZipper :: RL a wX wY -> FL a wY wZ -> FZipper a wX wZ |

focus :: FZipper a wX wY -> Maybe (Sealed2 a) #

leftmost :: FZipper p wX wY -> Bool #

left :: FZipper p wX wY -> FZipper p wX wY #

rightmost :: FZipper p wX wY -> Bool #

right :: FZipper p wX wY -> FZipper p wX wY #

jokers :: FZipper a wX wY -> FlippedSeal (FL a) wY #

See `clowns`

clowns :: FZipper a wX wY -> Sealed (RL a wX) #

"Clowns to the left of me, jokers to the right. Here I am, stuck in the middle of you" http://en.wikipedia.org/wiki/Stuck_in_the_Middle

flToZipper :: FL a wX wY -> FZipper a wX wY #

lengthFZ :: FZipper a wX wY -> Int #

nullFZ :: FZipper a wX wY -> Bool #

toEnd :: FZipper p wX wY -> FZipper p wX wY #

toStart :: FZipper p wX wY -> FZipper p wX wY #